YRPS.Web/Controllers/AuditController.cs
using System.Collections.Generic;
using System.Xml.Linq;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using YRPS.Core.Interfaces;
using YRPS.DTO.Log;
using YRPS.Services.Audit;
using Newtonsoft.Json;
using System;
using System.Text.RegularExpressions;
using Newtonsoft.Json.Linq;

namespace YRPS.Web.Controllers
{
    public class AuditController : BaseController
    {
        private readonly IAuditService _auditService;
        public AuditController(IAuditService auditService, IResponseDTO response,
         IHttpContextAccessor httpContextAccessor) : base(response, httpContextAccessor)
        {
            _auditService = auditService;
        }

        [HttpGet]
        public IActionResult Index()
        {
            return PartialView("Index");
        }

        [HttpGet]
        public IActionResult AllAuditLogs([DataSourceRequest]DataSourceRequest request, string tableName, string primaryKey, string action = "")        
        {
            var keyValue = @"{""Id"":" + primaryKey + "}";
            var auditFilter = new AuditLogFilterDto() { TableName = "Roles", Action = string.Empty, KeyValues = keyValue };
            var result = _auditService.GetAll(auditFilter);
            var records = (List<AuditLogDto>)result.Data;

            return PartialView("~/Views/Audit/_AuditHostory.cshtml", records);
        }
    }
}

YRPS.Web/Controllers/RoleController.cs
using System.Collections.Generic;
using System.Threading.Tasks;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using YRPS.Core.Interfaces;
using YRPS.DTO.Security.ApplicationRole;
using YRPS.Services.Security.Role;

namespace YRPS.Web.Controllers
{
    public class RoleController : BaseController
    {
        private readonly IRoleService _roleService;
        public RoleController(
         IRoleService roleService,
         IResponseDTO response,
         IHttpContextAccessor httpContextAccessor) : base(response, httpContextAccessor)
        {
            _roleService = roleService;
        }


        public IActionResult Index()
        {
            return View();
        }

        public IActionResult AllRoles([DataSourceRequest]DataSourceRequest request, string searchCriteria)
        {
            var result = _roleService.GetAllRoles(searchCriteria);
            var records = (List<ApplicationRoleDto>)result.Data;
            var dsResult = records.ToDataSourceResult(request);

            return Json(dsResult);
        }

        [HttpPost]
        public async Task<IActionResult> Create(ApplicationRoleDto applicationRoleDto)
        {
            _response = await _roleService.AddRole(applicationRoleDto);
            return Json(_response);
        }

        [HttpPost]
        public async Task<IActionResult> Update(ApplicationRoleDto applicationRoleDto)
        {
            _response = await _roleService.UpdateRole(applicationRoleDto);
            return Json(_response);
        }

        [HttpPost]
        public async Task<IActionResult> Remove(int roleId)
        {
            _response = await _roleService.RemoveRole(roleId);
            return Json(_response);
        }
    }
}

YRPS.Web/Views/Role/Index.cshtml
@{
    ViewData["Title"] = "Roles";
}

<script type="text/javascript">
    $(document).ready(function () {
        //Bind keypress event to textbox
        $('#searchCriteria').keypress(function (event) {
            var keycode = (event.keyCode ? event.keyCode : event.which);
            if (keycode == '13') {
                RefreshGrid();
            }
            //Stop the event from propogation to other handlers
            //If this line will be removed, then keypress event handler attached
            //at document level will also be triggered
            event.stopPropagation();
        });

    });

    function AuditModal(id) {
        debugger;
       // var gridAudit = $("#gridAudit").data("kendogrid");
       // gridAudit.datasource.transport.options.read.url = '@Url.Action("AllAuditLogs", "Audit")';// + '?tablename="roles"&&action=""&&primarykey=' + id;
       // gridAudit.datasource.read();


        $('#modalAuditBody').empty();

           $.ajax({
            type: "GET",
               url: '@Url.Action("AllAuditLogs", "Audit")?tablename="roles"&&primarykey=' + id,
              // data: { 'appointmentId': appointmentId, 'encounterId': encounterId },
               //async: true,
               success: OnSuccess,
               error: OnError
        });
            function OnSuccess(data) {
                debugger;
                $('#modalAuditBody').append(data);
                $('#auditModal').modal('show');

        }
        function OnError(data) {
            debugger;
                alert(data.responseText);
            alert('An eror has occured, please return back to your system administrator');
            return;
        }

    }

    function Export() {
        $("#grid").data("kendoGrid").saveAsExcel()
    }
        function RefreshGrid() {
        var searchCriteria = $('#searchCriteria').val();
        var grid = $("#grid").data("kendoGrid");
        grid.dataSource.transport.options.read.url = '@Url.Action("AllRoles", "Role")' + '?searchCriteria=' + searchCriteria;
        grid.dataSource.read();
    }


    function ItemDetails(data) {
        var html = '';
        html += '<a style="padding: 2px;" onclick=AddEditModal("' + data.Id + '","' + data.Name + '")>' + '<i aria-hidden="true" class="glyphicon glyphicon-pencil" title="Edit"></i></a>';
        html += '<a style="padding: 2px;" onclick=RemoveModal("' + data.Id + '","' + data.Name + '"' + ')>' + '<i aria-hidden="true" class="glyphicon glyphicon-remove" title="Remove"></i></a>';
        html += '<a style="padding: 2px;" onclick=AuditModal("' + data.Id + '")>' + '<i aria-hidden="true" class="glyphicon glyphicon-eye-open" title="Audit"></i></a>';

        return html;
    }

    function AddEditModal(id, name) {
        if (id != null && id != 0 && id != '') {
            $('#item-to-edit-delete').val(id);
            $('#roleName').val(name);
            $('#addEditHeaderLbl').text("Edit");
        }
        else {
            $('#addEditHeaderLbl').text("Create");
        }

        $("#divWarning").css("display", "none");
        $('#addEditModal').modal('show');
    }

    function CloseAddEditModal() {
        $('#item-to-edit-delete').val('');
        $('#roleName').val('')
        $("#divWarning").css("display", "none");
        $('#addEditModal').modal('hide');
    }

    function RemoveModal(id, name) {
        $('#item-to-edit-delete').val(id);
        $('#deletedRoleLbl').text(name);
        $('#deleteModal').modal('show');
    }

    function CloseRemoveModal() {
        $('#item-to-edit-delete').val('');
        $('#deletedRoleLbl').text('');
        $('#deleteModal').modal('hide');
    }

    function Save() {
        var responseMessage = '';
        var url = '';
        var id = $('#item-to-edit-delete').val();
        if (id == 0 || id == null || id == '' || id == -1) {
            url = '@Url.Action("Create","Role")';
            responseMessage = "Added";
        }
        else {
            url = '@Url.Action("Update","Role")';
            responseMessage = "Updated";
        }

        var warningMessage = [];
        var roleName = $('#roleName').val();
        if (roleName == '' || roleName == null) {
            warningMessage.push('Role Name is required');
        }

        if (warningMessage != '') {
            var htmlMessage = DisplayWarningMessage(warningMessage);
            $('#divWarning').html(htmlMessage);
            $("#divWarning").css("display", "block");
            return;
        }

        var role = new Object();
        role.Name = roleName;
        role.Id = id;

         $.ajax({
             type: "POST",
             url: url,
             data: role ,
            async: true,
            success: OnSuccess,
            error: OnError
        });
        function OnSuccess(data) {
            warningMessage = [];
            if (data != null && data.IsPassed) {
                warningMessage.push("Role is " + responseMessage + " successfully");
                RefreshGrid();
                CloseAddEditModal();
                DisplaySuccessMessage(warningMessage);
            }
            else {
                warningMessage.push(data.Message);
                var htmlMessage = DisplayWarningMessage(warningMessage);
                $('#divWarning').html(htmlMessage);
                $("#divWarning").css("display", "block");
            }
        }
        function OnError() {
            DisplayErrorMessage('An error has occured, please return back to system administrator');
            return;
        }
    }

    function Delete() {
          var warningMessage = [];
        $.ajax({
            type: "POST",
            url: '@Url.Action("Remove", "Role")',
            data: { roleId: $('#item-to-edit-delete').val() },
            async: true,
            success: OnSuccess,
            error: OnError
        });
        function OnSuccess(data) {
            if (data != null && data.IsPassed) {
                warningMessage.push("Role is removed successfully");
                RefreshGrid();
                CloseRemoveModal();
                DisplaySuccessMessage(warningMessage);
            }
            else {
                warningMessage.push(data.Message);
                var htmlMessage = DisplayWarningMessage(warningMessage);
                $('#deleteWarningMsg').html(htmlMessage);
                $("#deleteWarningMsg").css("display", "block");
            }
        }
        function OnError() {
            DisplayErrorMessage('An error has occured, please return back to system administrator');
            return;
        }
    }


</script>

<div class="panel page-header border-top-primary" style="padding-bottom: 0;">
    <div class="page-header-content">
        <div class="page-title">
            <h5>
                <span class="text-semibold">@ViewData["Title"]</span>
            </h5>
        </div>

        <div class="heading-elements">
            <form class="heading-form" action="#">
                <div class="form-group">
                    <div class="has-feedback">
                        <input type="search" class="form-control" placeholder="Search" id="searchCriteria">
                        <div class="form-control-feedback">
                            <i class="icon-search4 text-size-small text-muted"></i>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>

</div>


<div>
    <div class="col-lg-12">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-white">
                    <div class="panel-body">

                        <div>
                            <ul class="breadcrumb">
                                <li><a href="#" data-toggle="modal" onclick="AddEditModal('','')"><i class=" icon-plus22 position-left"></i> Add</a></li>
                                <li><a href="#" onclick="RefreshGrid()"><i class="icon-sync position-left"></i> Refresh</a></li>
                                <li><a href="#" onclick="Export()"><i class="icon-file-excel position-left"></i> Export</a></li>
                            </ul>
                        </div>

                        <div class="panel panel-flat table-responsive">

    @(Html.Kendo().Grid<YRPS.DTO.Security.ApplicationRole.ApplicationRoleDto>().Name("grid")
    .Columns(columns =>
    {
        columns.Bound(c => c.Name);
        columns.Template("#= ItemDetails(data) #").Width(80);

    })

    .Sortable()
    .Filterable()
    .Excel(excel => excel
                    .FileName("Roles")
                    .AllPages(true)
                    .Filterable(true)
                )
    .Pageable(pageable => pageable
    .PageSizes(true)
    .ButtonCount(5))

    .DataSource(dataSource => dataSource
    .Ajax()
    .Read(read => read.Action("AllRoles", "Role"))
)
                            )
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<input type="hidden" id="item-to-edit-delete" value="-1" />

<div id="addEditModal" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h5 class="modal-title"> <label id="addEditHeaderLbl"></label> Role</h5>
            </div>

            <div class="modal-body">
                <form>
                    <div class="alert alert-warning" id="divWarning" style="display:none">
                    </div>
                    <div class="form-group">
                        <label>Role Name</label>
                        <input type="text" id="roleName" class="form-control" placeholder="Role Name" required autofocus>
                    </div>
                </form>
            </div>

            <div class="modal-footer">
                <button type="button" class="btn btn-link" data-dismiss="modal">Cancel</button>
                <button type="button" class="btn btn-primary" onclick="Save()">Save</button>
            </div>
        </div>
    </div>
</div>

<div id="deleteModal" class="modal fade" role="dialog">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">
                    <span id="activeStatusHeader">

                    </span>
                </h4>
            </div>
            <div class="modal-body">
                <div id="deleteWarningMsg" style="display:none" class="alert alert-danger">

                </div>
                <p>Sure you want to <label id="activeStatusLbl" class="text-bold"></label> the selected role [ <label id="deletedRoleLbl"></label> ]</p>
            </div>
            <div class="modal-footer">
                <button type="submit" value="Delete" class="btn btn-danger" name="Delete" id="Delete" data-placement="top" onclick="Delete()" title="Submit Removing">
                    <span>
                        Remove
                    </span>
                </button>
            </div>
        </div>

    </div>
</div>

<div id="auditModal" class="modal fade" role="dialog">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">
                    Role Audit
                </h4>
            </div>
            <div class="modal-body">
                <div id="modalAuditBody">

                </div>
            </div>

        </div>
    </div>
</div>